<!DOCTYPE html>

<head>
    <style>
        p {
            color: blue;
        }
        
        #textField {
            color: red;
        }
    </style>
</head>

<!------------------------------------------------ Need to enable Cross-origin resource sharing--------------------------------------------------->

<body>

    <input id="inputForURL" type="url" placeholder="Paste website URL">
    <button type="button" id="getInfo">Get info</button>
    <p id="textField"></p>
    <p id="resultXpathAll"></p>
    <p id="resultXpathImg"></p>

    <script>
        document.getElementById("getInfo").onclick = function() {
            let pastedURL = document.getElementById("inputForURL").value;
            tags_calculation(pastedURL);
        };

        function tags_calculation(addressURL) {

            let webPageSource = new XMLHttpRequest();
            webPageSource.open("GET", addressURL);
            webPageSource.responseType = "document";
            webPageSource.send();
            webPageSource.onreadystatechange = function() {
                try {
                    if (webPageSource.readyState == 4 && webPageSource.status == !404) throw "Invalid URL";
                    if (webPageSource.readyState == 4 && webPageSource.status == 404) throw "HTTP " + webPageSource.status + " - Page not found";
                    if (webPageSource.readyState == 4 && webPageSource.status == 200) {

                        let source = webPageSource.responseXML;

                        let xpathAll = "//*";
                        let xpathImg = "//img";

                        let evaluator = new XPathEvaluator();

                        let expressionXpathAll = evaluator.createExpression(xpathAll);
                        let expressionXpathImg = evaluator.createExpression(xpathImg);

                        let resultXpathAll = expressionXpathAll.evaluate(source, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);
                        let resultXpathImg = expressionXpathImg.evaluate(source, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE);

                        document.getElementById("resultXpathAll").textContent = "Number of HTML form elements = " + resultXpathAll.snapshotLength;
                        document.getElementById("resultXpathImg").textContent = "Number of HTML image tags = " + resultXpathImg.snapshotLength;


                    }
                } catch (errorText) {
                    document.getElementById("textField").innerHTML = errorText;
                }
            }
        }
    </script>
</body>

</html>